"""
Script:   MultiFilter.py

Author:   Christian Rybovic
Class:    L-TIP-24-Do-a
Date:     06.11.2024
"""
import functools

EVEN_ONLY = lambda x : x % 2 == 0
ODD_ONLY  = lambda x : x % 2 != 0

ABOVE_20  = lambda x : x > 20
ABOVE_40  = lambda x : x > 40
ABOVE_60  = lambda x : x > 60
ABOVE_80  = lambda x : x > 80

BELOW_20  = lambda x : x < 20
BELOW_40  = lambda x : x < 40
BELOW_60  = lambda x : x < 60
BELOW_80  = lambda x : x < 80

POWEROF_3 = lambda x : x % 3 == 0
POWEROF_4 = lambda x : x % 4 == 0
POWEROF_5 = lambda x : x % 5 == 0
POWEROF_6 = lambda x : x % 6 == 0

class MultiFilter:
    def __init__(self, items):
        self.items = list(items)
        
    def Run(self, *func):
        for f in func:
            self.items = list(filter(f, self.items))
        return self.items

numbers = [1,2,3,4,5,10,20,30,33,35,40,41,42,43,55,58,59,77,78,79,44,60,66,68,88,89,90,96]
mf = MultiFilter(numbers)
filtered = mf.Run(ABOVE_20,BELOW_60,POWEROF_3,EVEN_ONLY)

print("Variante MutliFilter:", filtered)

ADD100 = lambda x : x + 100
print("Add 100 to all items:", list(map(ADD100, filtered)))

MULTIPLY = lambda x, y : x * y
print("Multiply:", functools.reduce(MULTIPLY, filtered))

# ----- Ohne MultiFilter (1) ----- #
filtered = filter(lambda x : x % 2 == 0, numbers)
filtered = filter(lambda x : 20 < x, filtered)
filtered = filter(lambda x : x % 3 == 0, filtered)
filtered = filter(lambda x : x < 60, filtered)
print("Variante 1:", list(filtered))

# ----- Ohne MultiFilter (2) ----- #
filtered = filter(lambda x : (x < 60) and (x %2 == 0) and (x > 20) and (x % 3 == 0), numbers)
print("Variante 2:", list(filtered))