"""
Script:   Model.py

Author:   Christian Rybovic
Class:    L-TIP-24-Do-a
Date:     14.11.2024
"""

class User:
    def __init__(self, username, password, mail):
        self.__username = username
        self.__mail = mail
        self.__password = password
        
    def GetUsername(self):
            return self.__username
        
    def GetMail(self):
            return self.__mail
        
    def SetMail(self, password, mail):
        self.__IsValidPassword(password)
        self.__mail = mail
        
    def __IsValidPassword(self, password):
        if(self.__password != password):
            raise Exception("Wrong password")
    
    def IsValidMail(mail):
        # valid mail contains "@" and "." and no " "
        if(("@" not in mail) or ("." not in mail) or (' ' in mail)):
            return False
        
        # valid mail has 1-64 for local part and 1-255 for domain part
        if(not (0 < len(mail.split("@")[0]) <= 64) or not (0 < len(mail.split("@")[1]) <= 255)):
            return False
        
        return True