"""
Script:   UnitTest.py

Author:   Christian Rybovic
Class:    L-TIP-24-Do-a
Date:     14.11.2024
"""

import unittest
import Model

class TestMethods(unittest.TestCase):
    #check if mail validation works as expected
    def test_mailvalidation(self):
        mail = "mail@example.ch"
        
        # check testmail is considered valid
        self.assertEqual(Model.User.IsValidMail(mail), True)
        
        # check missing "@" is detected
        self.assertEqual(Model.User.IsValidMail(mail.replace("@", "")), False)
        
        # check missing "." is detected
        self.assertEqual(Model.User.IsValidMail(mail.replace(".", "")), False)
        
        # check empty space is considered as false
        self.assertEqual(Model.User.IsValidMail(mail.replace("i", " ")), False) 

if __name__ == '__main__':
    unittest.main()