"""
Script:   Files.py

Author:   Christian Rybovic
Class:    L-TIP-24-Do-a
Date:     20.11.2024
"""
from datetime import datetime

class File:
    def __init__(self, name, size):
        self.__name = name
        self.__size = size
        self.__isDefault = True
        self.__application = ""
            
    def SetApplication(self, application):
        self.__application = application
        self.__isDefault = False
        
    def Open(self):
        if(self.__isDefault):
            print("Open with explorer")
        else:
            print("Open with", self.__application)
        
class DocFile(File):
    def __init__(self, name, size):
        self.lastModified = datetime.now()
        super().__init__(name, size)
        super().SetApplication("Office Word")
        
    def ConvertToPDF(self):
        print("Converting DOC to PDF")

class PdfFile(File):
    def __init__(self, name, size):
        self.createdBy = "Administrator"
        super().__init__(name, size)