"""
Script:   SandwichMaker.py

Author:   Christian Rybovic
Class:    L-TIP-24-Do-a
Date:     27.11.2024
"""
from abc import ABC, abstractmethod

class Sandwich():
    def __init__(self):
        self.__ingredients = []
        self.__totalPrice = 2.00
    
    def add(self, item):
        self.__ingredients.append(item)
        self.__totalPrice += item.price()
        return self

    def make(self):
        print("Making sandwich with:")
        for i in self.__ingredients:
            print( "   {0:10}+ {1}".format(i.name(), i.price()))
        print("Total: {0}\n\n".format(round(self.__totalPrice,2)))
            
class Ingredient(ABC):
    @abstractmethod
    def name(self):
        pass
    
    @abstractmethod
    def price(self):
        pass
    
class Tomato(Ingredient):
    def name(self):
        return "Tomato"
    
    def price(self):
        return 0.35
        
class Chicken(Ingredient):
    def name(self):
        return "Chicken"
    
    def price(self):
        return 1.15
        
class Onion(Ingredient):
    def name(self):
        return "Onion"
    
    def price(self):
        return 0.25
        
class Bacon(Ingredient):
    def name(self):
        return "Bacon"
    
    def price(self):
        return 1.65

# Classical
sandwich = Sandwich()
sandwich.add(Onion())
sandwich.add(Chicken())
sandwich.add(Onion())
sandwich.make()

# Method chaining
Sandwich().add(Tomato()).add(Bacon()).add(Onion()).make()