"""
Script:   ProxyPattern.py

Author:   Christian Rybovic
Class:    L-TIP-24-Do-a
Date:     12.12.2024
"""
class Hotel:
    def __init__(self, name):
        self.name = name
        self.rooms = []

    def book(self, guest):
        self.rooms.append(guest)
        print("{0}: Reservation for {1}".format(self.name, guest))

class HotelProxy:
    def __init__(self, hotel):
        self.hotel = hotel

    def book(self, guest):
        if (len(self.hotel.rooms) < 3):
            self.hotel.book(guest)
        else:
            print("No free room at {0}!".format(self.hotel.name))

hotel = Hotel("Hotel Krone")
proxy = HotelProxy(hotel)

proxy.book("Max")
# Hotel Krone: Reservation for Max

proxy.book("Florian")
# Hotel Krone: Reservation for Florian

proxy.book("Andrea")
# Hotel Krone: Reservation for Andrea

proxy.book("Thomas")
# No free room at Hotel Krone!