"""
Script:   Packaging.py

Author:   Christian Rybovic
Class:    L-TIP-24-Do-a
Date:     07.01.2025
"""
import threading
import time
import queue
from tkinter import *

def addPackage():
    print('[+] Package of size {0} added'.format(textbox.get("1.0",'end-1c')))
    waitingQueue.put(textbox.get("1.0",'end-1c'))

def worker(number, waitingQueue):
    while (True):
        productCount = waitingQueue.get()
        print('[!] Worker {0} started with package of size {1}'.format(number, str(productCount)))
        time.sleep(int(productCount) / 2)
        print('[-] Worker {0} finished package of size {1}'.format(number, str(productCount)))

waitingQueue = queue.Queue()
threading.Thread(target=worker, args=("1", waitingQueue), daemon=True).start()
threading.Thread(target=worker, args=("2", waitingQueue), daemon=True).start()

window = Tk()
window.geometry("200x110")
window.title("Packaging")

label = Label(window, text="Enter numbers to package:")
label.place(x=10,y=10)

textbox = Text(window, height=1, width=20)
textbox.place(x=15,y=40)

button = Button(window, text="Pack", width=22, command=addPackage)
button.place(x=15,y=70)